/*
  File: test_queue.c
  ------------------
  A program that tests the queue abstract data type abstraction.
*/

#include <stdio.h>
#include <stdlib.h>


#include "QueueADT.h"


/*
  Function: ElementPrinter
  Usage: PrettyPrintQueue(q, &ElementPrinter);
  --------------------------------------------
  Function that prints an element of the queue. To be used with the
  PrettyPrintQueue function of the queue asbtract data type.
*/

void ElementPrinter(void* p)
{
  printf(" %g", *((double*)p));
}


/* Main program */

int main(int argc, char** argv)
{
  double a[] = {34, 56, 3, 2, 7, 78, 22, 55, 1, 0, -23};
  unsigned int n = sizeof(a) / sizeof(a[0]), i;

  /* create a new queue */
  QueueADT q = NewQueue();

  /* insert the elements of the array into the queue */
  for (i = 0; i < n; ++i) {
    Enqueue(q, (void*)(&a[i]));
    printf("\nvvvvvvv\n");
    printf("Enqueueing element: %g\n", a[i]);
    PrettyPrintQueue(q, &ElementPrinter);
    printf("^^^^^^^\n\n");
  }

  printf("*******\n");
  printf("*******\n\n");

  /* remove all elements from the queue */
  while ( QueueLength(q) > 0 ) {
    printf("\nvvvvvvv\n");
    printf("Dequeueing element:\n");
    DeQueue(q);
    PrettyPrintQueue(q, &ElementPrinter);
    printf("^^^^^^^\n\n");
  }

  /* free the memory allocated for the queue */
  FreeQueue(q);

  return 0;
}

